﻿using HarmonyLib;
using CoreLib;
using Unity.Entities;
using Il2CppSystem.Collections.Generic;
using System;
using Unity.Collections;

namespace AutoPlant
{

    [HarmonyPatch]
    public static class AutoPlantPatch
    {
        //private static System.Collections.Generic.Dictionary<ObjectID, ObjectID> plantToSeed =
        //    new System.Collections.Generic.Dictionary<ObjectID, ObjectID>()
        //{
        //    {ObjectID.BombPepperPlant,ObjectID.BombPepperSeed },
        //    {ObjectID.HeartBerryPlant,ObjectID.HeartBerrySeed },
        //    {ObjectID.BloatOatPlant,ObjectID.BloatOatSeed },
        //    {ObjectID.CarrockPlant,ObjectID.CarrockSeed },
        //    {ObjectID.GlowingTulipPlant,ObjectID.GlowingTulipSeed },
        //    {ObjectID.GrubKapokPlant,ObjectID.GrubKapokSeed },
        //    {ObjectID.GrumpkinPlant,ObjectID.GrumpkinSeed },
        //    {ObjectID.PewpayaPlant,ObjectID.PewpayaSeed },
        //    {ObjectID.PinegrapplePlant,ObjectID.PinegrappleSeed },
        //    {ObjectID.PuffungiPlant,ObjectID.PuffungiSeed }
        //};
        //private static PlayerController pc;
        //private static SaveManager save;
        //private static int talentIndex = 6;
        //private static SkillTalentsTable table;
        //private static World _world;

        [HarmonyPostfix]
        [HarmonyPatch(typeof(SceneHandler), nameof(SceneHandler.Start))]
        public static void OnSceneStart()
        {
            World world = Manager.ecs.ServerWorld;
            if (world != null)
            {
                AutoPlantSystem.instance.OnServerStarted(world);
                //_world = world;
                UnityEngine.Debug.Log("Loading AutoPlant system!");
            }
        }

        [HarmonyPostfix]
        [HarmonyPatch(typeof(RadicalPauseMenuOption_ExitToTitle), nameof(RadicalPauseMenuOption_ExitToTitle.OnActivated))]
        public static void  Q()
        {
            AutoPlantSystem.instance.destroyWorld();
        }

        //[HarmonyPostfix]
        //[HarmonyPatch(typeof(Plant), nameof(Plant.OnTakeDamage))]
        //public static void S(Plant __instance)
        //{
        //    if (!AutoPlantSystem.instance.isZero() && !__instance.hasReachedFinalStage && __instance.currentHealth <= 3)
        //    {
        //        AutoPlantSystem.instance.setZero();

        //    }
        //}

        //[HarmonyPostfix]
        //[HarmonyPatch(typeof(Plant), nameof(Plant.OnDeath))]
        //public static void E(Plant __instance)
        //{
        //    if (__instance.hasReachedFinalStage)
        //    {
        //        if (pc == null) pc = Players.GetCurrentPlayer();
        //        if (save == null) save = GameManagers.GetMainManager()._saveManager;
        //        List<int> points = save.GetSkillTalentTreesPoints(SkillID.Gardening);
        //        int level = points[talentIndex];
        //        if (table == null) table = GameManagers.GetMainManager()._modManager.skillTalentsTable;
        //        int point = table.GetConditionDataForSkillTalent(SkillID.Gardening, talentIndex, level).value;
        //        int varia = 0;
        //        if (__instance.variation == 0)
        //        {
        //            UnityEngine.Random.seed = Math.Abs(Guid.NewGuid().GetHashCode());
        //            int rate = UnityEngine.Random.RandomRange(0, 100);
        //            if (rate < point && __instance.plantID != ObjectID.GrubKapokPlant) varia = 1;
        //            pc.playerCommandSystem.CreateEntity(__instance.plantID - 1, __instance.RenderPosition, varia);
        //        }
        //        else if (__instance.variation == 2)
        //        {
        //            pc.playerCommandSystem.CreateEntity(__instance.plantID - 1, __instance.RenderPosition, 1);
        //        }
        //    }
        //}

        //[HarmonyPostfix]
        //[HarmonyPatch(typeof(DestroyNearbyEntitiesOnDeathSystem), nameof(DestroyNearbyEntitiesOnDeathSystem.OnUpdate))]
        //public static void T(DestroyNearbyEntitiesOnDeathSystem __instance)
        //{
            
        //    EntityQuery query = __instance.DestroyNearbyEntitiesOnDeathSystem_LambdaJob_0_Query;
        //    NativeArray<Entity> result = query.ToEntityArray(Allocator.Temp);

        //    foreach (Entity entity in result)
        //    {
        //        UnityEngine.Debug.Log(EntityUtility.GetObjectID(entity, _world).ToString()); 
        //    }
        //    result.Dispose();
        //}
    }
}
